﻿#include "MeshfronObj.h"

//
//
//
ObjMesh::ObjMesh()
{
    memset(this, 0,sizeof(ObjMesh));
}
//
//
//
ObjMesh::~ObjMesh()
{

}
//
//
//
void ObjMesh::Init()
{

}
//
//
//マテリアルファイルを読み込む関数
bool ObjMesh::LoadMaterialFromFile(char* FileName,MY_MATERIAL** ppMaterial)
{
	//マテリアルファイルを開いて内容を読み込む
	FILE* fp = NULL;
	fp=fopen(FileName, "rt");
	char key[100] = { 0 };
	vec4 v(0, 0, 0, 0);

	//マテリアル数を調べる
	while (!feof(fp))
	{
		//キーワード読み込み
		fscanf(fp, "%s ", key, sizeof(key));
		//マテリアル名
		if (strcmp(key, "newmtl") == 0)
		{
			m_numMaterials++;
		}
	}
	MY_MATERIAL* pMaterial = new MY_MATERIAL[m_numMaterials];

	//本読み込み
	fseek(fp, SEEK_SET, 0);
	int iMCount = -1;

	while (!feof(fp))
	{
		//キーワード読み込み
		fscanf(fp, "%s ", key, sizeof(key));
		//マテリアル名
		if (strcmp(key, "newmtl") == 0)
		{
			iMCount++;
			fscanf(fp, "%s ", key, sizeof(key));
			strcpy(pMaterial[iMCount].szName, key);
		}
		//Ka　アンビエント
		if (strcmp(key, "Ka") == 0)
		{
			fscanf(fp, "%f %f %f", &v.x, &v.y, &v.z);
			pMaterial[iMCount].Ka = v;
		}
		//Kd　ディフューズ
		if (strcmp(key, "Kd") == 0)
		{
			fscanf(fp, "%f %f %f", &v.x, &v.y, &v.z);
			pMaterial[iMCount].Kd = v;
		}
		//Ks　スペキュラー
		if (strcmp(key, "Ks") == 0)
		{
			fscanf(fp, "%f %f %f", &v.x, &v.y, &v.z);
			pMaterial[iMCount].Ks = v;
		}
		//map_Kd　テクスチャー
		if (strcmp(key, "map_Kd") == 0)
		{
			fscanf(fp, "%s", &pMaterial[iMCount].szTextureName, sizeof(pMaterial[iMCount].szTextureName));
			//テクスチャーを作成
			pMaterial[iMCount].texture = CreateTextureFromBMPFile(pMaterial[iMCount].szTextureName);
			if (pMaterial[iMCount].texture == -1)
			{
				return false;
			}
		}
	}
	fclose(fp);

	*ppMaterial = pMaterial;

	return true;
}
//
//HRESULT LoadMeshFromOBJ(LPSTR FileName,MY_MESH* pMesh)
//OBJファイルを読み込む関数
bool ObjMesh::LoadMeshFromOBJ(const char* FileName)
{
	float x, y, z;
	int v1 = 0, v2 = 0, v3 = 0;
	int vn1 = 0, vn2 = 0, vn3 = 0;
	int vt1 = 0, vt2 = 0, vt3 = 0;
	unsigned int dwVCount = 0;//読み込みカウンター
	unsigned int dwVNCount = 0;//読み込みカウンター
	unsigned int dwVTCount = 0;//読み込みカウンター
	unsigned int dwFCount = 0;//読み込みカウンター

	char key[200] = { 0 };
	//OBJファイルを開いて内容を読み込む
	FILE* fp = NULL;
	fp=fopen(FileName, "rt");

	//事前に頂点数、ポリゴン数を調べる
	while (!feof(fp))
	{
		//キーワード読み込み
		fscanf(fp, "%s ", key, sizeof(key));
		//マテリアル読み込み
		if (strcmp(key, "mtllib") == 0)
		{
			fscanf(fp, "%s ", key, sizeof(key));
			LoadMaterialFromFile(key, &m_pMaterial);
		}
		//頂点
		if (strcmp(key, "v") == 0)
		{
			m_mesh.dwNumVert++;
		}
		//法線
		if (strcmp(key, "vn") == 0)
		{
			dwVNCount++;
		}
		//テクスチャー座標
		if (strcmp(key, "vt") == 0)
		{
			dwVTCount++;
		}
		//フェイス（ポリゴン）
		if (strcmp(key, "f") == 0)
		{
			m_mesh.dwNumFace++;
		}
	}

	//一時的なメモリ確保（頂点バッファとインデックスバッファ）
	MY_VERTEX* pvVertexBuffer = new MY_VERTEX[m_mesh.dwNumFace * 3];
	vec3* pvCoord = new vec3[m_mesh.dwNumVert];
	vec3* pvNormal = new vec3[dwVNCount];
	vec2* pvTexture = new vec2[dwVTCount];

	//本読み込み
	fseek(fp, SEEK_SET, 0);
	dwVCount = 0;
	dwVNCount = 0;
	dwVTCount = 0;
	dwFCount = 0;

	while (!feof(fp))
	{
		//キーワード 読み込み
		memset(key,0, sizeof(key));
		fscanf(fp, "%s ", key, sizeof(key));

		//頂点 読み込み
		if (strcmp(key, "v") == 0)
		{
			fscanf(fp, "%f %f %f", &x, &y, &z);
			pvCoord[dwVCount].x = -x;//OBJは右手、Direct3Dは左手座標系。
			pvCoord[dwVCount].y = y;
			pvCoord[dwVCount].z = z;
			dwVCount++;
		}

		//法線 読み込み
		if (strcmp(key, "vn") == 0)
		{
			fscanf(fp, "%f %f %f", &x, &y, &z);
			pvNormal[dwVNCount].x = -x;//OBJは右手、Direct3Dは左手座標系。
			pvNormal[dwVNCount].y = y;
			pvNormal[dwVNCount].z = z;
			dwVNCount++;
		}

		//テクスチャー座標 読み込み
		if (strcmp(key, "vt") == 0)
		{
			fscanf(fp, "%f %f", &x, &y);
			pvTexture[dwVTCount].x = x;
			pvTexture[dwVTCount].y = -y;//OBJファイルはY成分が逆なので合わせる
			dwVTCount++;
		}
	}

	//マテリアルの数だけインデックスバッファーを作成

	//フェイス　読み込み　バラバラに収録されている可能性があるので、マテリアル名を頼りにつなぎ合わせる
	bool boFlag = false;
	int* piFaceBuffer = new int[m_mesh.dwNumFace * 3];//３頂点ポリゴンなので、1フェイス=3頂点(3インデックス)
	dwFCount = 0;
	unsigned int dwPartFCount = 0;
	for (unsigned int i = 0; i<m_numMaterials; i++)
	{
		dwPartFCount = 0;
		fseek(fp, SEEK_SET, 0);

		while (!feof(fp))
		{
			//キーワード 読み込み
			memset(key,0, sizeof(key));
			fscanf(fp, "%s ", key, sizeof(key));

			//フェイス 読み込み→頂点インデックスに
			if (strcmp(key, "usemtl") == 0)
			{
				fscanf(fp, "%s ", key, sizeof(key));
				if (strcmp(key, m_pMaterial[i].szName) == 0)
				{
					boFlag = true;
				}
				else
				{
					boFlag = false;
				}
			}
			if (strcmp(key, "f") == 0 && boFlag == true)
			{
				if (m_pMaterial[i].texture >=0)//テクスチャーありサーフェイス
				{
					fscanf(fp, "%d/%d/%d %d/%d/%d %d/%d/%d", &v1, &vt1, &vn1, &v2, &vt2, &vn2, &v3, &vt3, &vn3);
				}
				else//テクスチャー無しサーフェイス
				{
					fscanf(fp, "%d//%d %d//%d %d//%d", &v1, &vn1, &v2, &vn2, &v3, &vn3);
				}

				//インデックスバッファー
				piFaceBuffer[dwPartFCount * 3] = dwFCount * 3;
				piFaceBuffer[dwPartFCount * 3 + 1] = dwFCount * 3 + 1;
				piFaceBuffer[dwPartFCount * 3 + 2] = dwFCount * 3 + 2;
				//頂点構造体に代入
				pvVertexBuffer[dwFCount * 3].vPos = pvCoord[v1 - 1];
				pvVertexBuffer[dwFCount * 3].vNorm = pvNormal[vn1 - 1];
				pvVertexBuffer[dwFCount * 3].vTex = pvTexture[vt1 - 1];
				pvVertexBuffer[dwFCount * 3 + 1].vPos = pvCoord[v2 - 1];
				pvVertexBuffer[dwFCount * 3 + 1].vNorm = pvNormal[vn2 - 1];
				pvVertexBuffer[dwFCount * 3 + 1].vTex = pvTexture[vt2 - 1];
				pvVertexBuffer[dwFCount * 3 + 2].vPos = pvCoord[v3 - 1];
				pvVertexBuffer[dwFCount * 3 + 2].vNorm = pvNormal[vn3 - 1];
				pvVertexBuffer[dwFCount * 3 + 2].vTex = pvTexture[vt3 - 1];

				dwPartFCount++;
				dwFCount++;
			}
		}
		if (dwPartFCount == 0)//使用されていないマテリアル対策
		{
			continue;
		}

		//インデックスバッファーを作成
		GLuint indexBuffer;
		glGenBuffers(1, &indexBuffer);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indexBuffer);
		glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(int)*dwPartFCount*3, piFaceBuffer, GL_STATIC_DRAW);

		m_mesh.indexBuffer.push_back(indexBuffer);
		m_pMaterial[i].dwNumFace = dwPartFCount;
	}
	delete[] piFaceBuffer;
	fclose(fp);

	//バーテックスバッファーを作成 interleave
	glGenBuffers(1, &m_mesh.positionBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, m_mesh.positionBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(MY_VERTEX)*dwFCount*3, pvVertexBuffer, GL_STATIC_DRAW);

	//一時的な入れ物は、もはや不要
	delete pvCoord;
	delete pvNormal;
	delete pvTexture;
	delete[] pvVertexBuffer;

	return true;
}
//
//
//
GLuint ObjMesh::CreateTextureFromBMPFile(const char * imagepath)
{
	FILE * fp=fopen(imagepath, "rb");
	if (!fp)
	{
		printf("ファイルを開けません\n");
		return 0;
	}
	//BMPヘッダーは54バイト
	unsigned char header[54];
	if (fread(header, 1, 54, fp) != 54)
	{
		printf("ビットマップファイルではありません\n");
		return 0;
	}
	//ビットマップであれば"BM"ヘッダーがあるはず
	if (header[0] != 'B' || header[1] != 'M')
	{
		printf("ビットマップファイルではありません\n");
		return 0;
	}
	// 24bitカラーかどうか
	if (*(int*)&(header[30]) != 0 || *(int*)&(header[28]) != 24)
	{
		printf("24ビットカラーではありません");
		return 0;
	}
	//ピクセルデータを読み込む
	unsigned int width = *(int*)&(header[18]);
	unsigned int height = *(int*)&(header[22]);
	unsigned int size = *(int*)&(header[34]);

	unsigned char* data = new unsigned char[size];
	fread(data, 1, size, fp);
	//この時点でもはやファイルは不要
	fclose(fp);

	//空（から）のテクスチャーを作成
	GLuint id;
	glGenTextures(1, &id);
	//テクスチャーをバインドして、これからそのテクスチャーにデータを送り込むことを指示する
	glBindTexture(GL_TEXTURE_2D, id);
	// ピクセルデータをテクスチャーに送り込む
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, GL_BGR, GL_UNSIGNED_BYTE, data);
	//この時点でメモリー上のデータは不要になる
	delete data;
	//テクスチャーの仕様を設定
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glGenerateMipmap(GL_TEXTURE_2D);

	return id;
}
