﻿#include <stdio.h>
#include <vector>
#include<glm/glm.hpp>
#include<glm/gtc/matrix_transform.hpp>
#include <GL/gl.h>
#include<GL/glx.h>
#include<GL/glext.h>

using namespace glm;
using namespace std;

struct MY_VERTEX
{
	vec3 vPos;
	vec3 vNorm;
	vec2 vTex;
};
struct MY_MESH
{
	unsigned int dwNumVert;
	unsigned int dwNumFace;
	GLuint positionBuffer;
	GLuint normalBuffer;
	GLuint uvBufffer;
	vector<GLuint> indexBuffer;
};
//オリジナル　マテリアル構造体
struct MY_MATERIAL
{
	char szName[100];
	vec4 Ka;//アンビエント
	vec4 Kd;//ディフューズ
	vec4 Ks;//スペキュラー
	char szTextureName[100];//テクスチャーファイル名
	GLuint texture;
	unsigned int dwNumFace;//そのマテリアルであるポリゴン数
	MY_MATERIAL()
	{
		memset(this, 0,sizeof(MY_MATERIAL));
	}
	~MY_MATERIAL()
	{
	}
};
//
//
//
class ObjMesh
{
public:

	MY_MESH m_mesh;
	int m_numMaterials;
	MY_MATERIAL* m_pMaterial;
	ObjMesh();
	~ObjMesh();
	void Init();
	bool LoadMaterialFromFile(char* FileName, MY_MATERIAL** ppMaterial);
	bool LoadMeshFromOBJ(const char* FileName);
	GLuint CreateTextureFromBMPFile(const char * imagepath);
};
